\\ Copyright 2016, 2017 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.

default(recover,0);
read("dragon-defines.gp");

check_count = 0;
check_exact(got,want,name="") =
{
  check_count++;
  if(got!= want,
     print("wrong "name);
     print("got  "got);
     print("want "want);
     quit(1),
     print("ok "check_count" "name));
}

\\-----------------------------------------------------------------------------

frac_den=15;
k=16;
num_is_triple(num) =
{
  my(den=frac_den*2^k,
     z=dragon_fpoint(num/den),
     count=0);
  \\ print(num," at ",z);
  for(i=max(0,num-8*frac_den), num+8*frac_den,
     my(z2=dragon_fpoint(i/den));
     \\ print("  other ",i," at ",z2);
     if(z==z2,count++));
  return(count==3);
}
dragon_fpoint == memoize(dragon_fpoint);

\\num_is_triple(13)
{
  prev=13;
  for(num=14,100,
     if(num_is_triple(num),
        print(num"  "num-prev);
        prev=num));
}

\\ 7ths
\\    1    2   3    4  5  6   7  8   9
\\ [205, 140, 13,  87, 0, 0, 10, 0,  5, 0, 0, 0]    to 1000
\\ [421, 279, 27, 176, 0, 0, 19, 0, 10, 0, 0, 0]  to 2000

\\ 15ths
\\ diff 21 at num=73 prev=52
\\ diff 21 at num=428 prev=407
\\    1   2   3  4 5 6 7  8  10 11                  20 21
\\ [ 70, 64, 51,29,5,0,0,14,0,4, 9, 0,0,0,0,0,0,0,0, 9, 3 ] 1000
\\ [152,128,103,61,9,0,0,26,0,8,17, 0,0,0,0,0,0,0,0, 20,5 ] 2000
{
  prev=13;
  my(seen=vector(21));
  for(num=14,1000,
     if(num_is_triple(num),
        my(diff=num-prev);
        \\ print(diff);
        seen[diff]++;
        if(diff==21,print("diff 21 at num="num" prev="prev));
        prev=num));
  seen
}
