\\ Copyright 2016, 2017 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.


default(recover,0);
read("pol-pfrac.gp");
read("pol-ascend.gp");
read("dragon-defines.gp");

check_count = 0;
check_exact(got,want,name="") =
{
  check_count++;
  if(got!= want,
     print("wrong "name);
     print("got  "got);
     print("want "want);
     quit(1),
     print("ok "check_count" "name));
}

\\-----------------------------------------------------------------------------

gDO_distinct_total(x) = {
    1/4
  + (-4/17)/(1 - x)
  + 1/68 * (-1 + 9*(2*x) - 4*(2*x)^2)/(1 - (2*x) - 2*(2*x)^3);
}
print("by gf ", gf_terms(gDO_distinct_total(x),16));

DO_distinct_total_by_n(k) = {
  my(m=Map());
  for(n=1,2^k,
      my(an=dragon_n_to_arm_and_other(n));
      if(an[1]==0 && an[2]<n,
         mapput(m, n-an[2], 1)));
  if(#m, vecsum(Mat(m)[,1]));
}
print("by n  ", vector(10,k,k--; DO_distinct_total_by_n(k)))

pol_ascending_print(pol_partial_fractions( \
                    (-1 + 9*(2*x) - 4*(2*x)^2)/(1 - (2*x) - 2*(2*x)^3)));
pol_ascending_print(pol_partial_fractions( \
                    -1/4*gdJA(2*x)/x^2 + 9/2*gdJA(2*x)/x - 4*gdJA(2*x)));

DO_distinct_total(k) =
{
  if(k==0,0,
     1/68 * 2^k * (-4*dJA(k) + 9*dJA(k+1) - dJA(k+2)) - 4/17);
  
}
print("by f  ", vector(16,k,k--; DO_distinct_total(k)))
check_exact(vector(100,k,k--; DO_distinct_total(k)), \
            gf_terms(gDO_distinct_total(x),100));

check_exact(vector(10,k,k--; DO_distinct_total_by_n(k)), \
            vector(10,k,k--; DO_distinct_total(k)));


\\-----------------------------------------------------------------------------
DO_distinct_total_by_low(k) =
{
  my(debug=0);
  if(debug,print("\nDO_distinct_total_by_low() k="k));

  \\ single run
  sum(l=2,k-2,              \\ low zeros and m and 1
        if(debug,print("l="l" "2^l));
        2^l)
  \\ low run then recurse
  + 
  sum(l=0,k-3,
      my(t=DO_distinct_total(k-l-3) * 2^(l+3));
      if(t>0,
         if(debug,print("recurse l="l" "k-l-2"  t="t"  values "t+2^(l+2)","t-2^(l+2)));
         t+2^(l+2)  + t-2^(l+2)));
}
 DO_distinct_total_by_low(4)
  DO_distinct_total_by_low(5)
  DO_distinct_total_by_low(6)
  DO_distinct_total_by_low(7)
 print("by f  ", vector(16,k,k--; DO_distinct_total_by_low(k)))

check_exact(vector(10,k,k--; DO_distinct_total_by_low(k)), \
            vector(10,k,k--; DO_distinct_total(k)));

\\-----------------------------------------------------------------------------
DO_distinct_single_run(k) =
{
  sum(l=2,k-2,              \\ low zeros and m and 1
        2^l);
}
print("single run ", vector(12,k,k--; DO_distinct_single_run(k)))
\\ A028399 a(n) = 2^n - 4

DO_distinct_single_run_formula(k) = if(k<3,0, 2^(k-1) - 4);
check_exact(vector(10,k,k--; DO_distinct_single_run_formula(k)), \
            vector(10,k,k--; DO_distinct_single_run(k)));

\\-----------------------------------------------------------------------------
\\ 
my(k=5); DO_distinct_total(k) / JA(k) / 2^k * 1.0
my(k=10); DO_distinct_total(k) / JA(k) / 2^k * 1.0
my(k=100); DO_distinct_total(k) / JA(k) / 2^k * 1.0
my(k=1000); DO_distinct_total(k) / JA(k) / 2^k * 1.0

print1("gJA  ");pol_ascending_print(pol_partial_fractions(2*x^2*gJA(x)));
print1("gdJA ");pol_ascending_print(pol_partial_fractions(gdJA(x)));

check_exact(vector(20,k,k++; dJA(k)), \
            vector(20,k,k++; 2*JA(k-2)+1))

check_exact(vector(20,k,k--; 2*JA(k)), \
            vector(20,k,k--; -JA(k+2)+JA(k+3)-1))

DO_distinct_total_by_JA(k) =
{
  if(k<2,0,
     1/68 * 2^k * (-8*JA(k-2) + 18*JA(k-1) - 2*JA(k) + 4) - 4/17);
}
check_exact(vector(100,k,k--; DO_distinct_total_by_JA(k)), \
            gf_terms(gDO_distinct_total(x),100));

DO_distinct_total_by_JA(k) =
{
  if(k<2,0,
     1/68 * 2^k * (+ 18*JA(k-1) + 2*JA(k) - 4*JA(k+1) + 8) - 4/17);
}
check_exact(vector(100,k,k--; DO_distinct_total_by_JA(k)), \
            gf_terms(gDO_distinct_total(x),100));

DO_distinct_total_by_JA(k) =
{
  if(k<2,0,
     1/68 * 2^k * (2*JA(k) - 13*JA(k+1) + 9*JA(k+2) - 1) - 4/17);
}
check_exact(vector(100,k,k--; DO_distinct_total_by_JA(k)), \
            gf_terms(gDO_distinct_total(x),100));

1/68*(2 - 13*r + 9*r^2)
1/34 - 13/68*r + 9/68*r^2