\\ Copyright 2014, 2015 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.


read("../tools/memoize.gp");
read("pol-pfrac.gp");

b = 1+I;
L(k) = if(k<0,error("L k<0"), k<=3,2^k, L(k-1) + 2*L(k-3));
L=memoize(L);
R(k)=1 + sum(j=0,k-1, L(j));
R = memoize(R);
RQ(k)=1 + sum(j=0,k-1, LQ(j));
RQ = memoize(RQ);
B(k) = R(k+1);
A(k) = 2^(k-1) - B(k)/4;
JA(k) = A(k+1) - 2*A(k);
JEQ(k) = (3/5 + 1/5*I)*b^k - (1/10 - 3/10*I)*(-1)^k;
LQ(k) = if(k<0,error("LQ() is for k>=0")); \
        if(k==0,return(1)); \
        if(k<=3,return(2^(k-1))); \
        LQ(k-1) + 2*LQ(k-3);
LQ = memoize(LQ);
gLQ(x) = (1     + x^2) / (1 - x - 2*x^3);
gRQ(x) = (1 + x + x^2) / (1-x-2*x^3);
gBQ(x) = (2 + x + 2*x^2) / (1-x-2*x^3);
\\ LQ+RQ == BQ

gJA(x) = x^3 / ((1 - x - 2*x^3)*(1-x));
\\ gJA(x) == 1/2*( - 1/(1-x) + 1/(1-x-2*x^3) )

\\-----------------------------------------------------------------------------

g = 3*x^8*gLQ(x) + 4*x^8*gRQ(x) + x^8*gJA(x) + x^7*gJA(x);
{
  for(i=-10,12,
     my(v=pol_partial_fractions(g*x^i));
     my(num = numerator(v[#v]));
     my(den = denominator(v[#v]));
     num /= polcoeff(den,0);
     my(a=polcoeff(num,0));
     my(b=polcoeff(num,1));
     my(c=polcoeff(num,2));
     my(g=gcd([a,b,c]));
     if(a<=0&&b<=0&&c<=0, g=-g);
     a /= g;
     b /= g;
     c /= g;
     print("i="i,"   ",a," ",b," ",c,"   g=",g);
  );
}

pol_partial_fractions(g*x^-8 - 4*gBQ(x))
pol_partial_fractions(g*x^-5 - 2*gLQ(x))
pol_partial_fractions(g*x^-7 - 4*gRQ(x))