\\ Copyright 2016, 2017 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.

default(recover,0);
read("dragon-defines.gp");

check_count = 0;
check_exact(got,want,name="") =
{
  check_count++;
  if(got!= want,
     print("wrong "name);
     print("got  "got);
     print("want "want);
     quit(1),
     print("ok "check_count" "name));
}

\\-----------------------------------------------------------------------------
\\ hulls for right side
\\ wrong, not all enc0 forms remain enc always
{
  segs_enclose0 = [
          [ 0, -1 ],
          [ -2, 1 ],
          [ -2, -I ],
          [ -1-I, -1 ],
          [ -1-I, -I ],
          [ -2*I, -1 ],
          [ -2*I, 1 ],
          [ 2-2*I, -1 ],
          [ 2-2*I, I ],
          [ 2, -I ],
          [ 2, -1 ]
          ];
}
{
  segs_enclose1 = [
          [ 2, -1 ],
          [ 2, I ],
          [ 2+2*I, -I ],
          [ 2+2*I, -1 ],
          [ 1+I, I ],
          [ 1+I, -1 ],
          [ -1+I,  1 ],
          [ -1+I, -I ],
          [ 0, -1 ]
          ];
}

{
  segs = Set(concat([segs_enclose0,
                segs_enclose1,
                [
                 [ 0, 1 ],

                 [ 2+2*I, -I ],
                 [ 1+I, -1 ],
                 [ -1+I,  1 ],
                 [ -1+I, -I ],

                 \\ extras
                 [ 0, I ],
                 [ 0, -I ],
                 [ 1-I, -I ],
                 [ 1-I, I ],
                 [ -1-I, 1 ],
                 [ -1-I, I ],
                 [ 1-I, -1 ],
                 [ 1+I, -I ],
                 [ 1+I, I ],

                 \\ extras for expand1
                 [ 1+I, 1 ],
                 [-2*I, I ],
                 [ 1-I, 1 ]
                ]
                    ]));
}

\\-----------------------------------------------------------------------------
\\ hulls all around
{
  segs_enclose0 = [
          [ -2, -I ],
          [ -1-I, -1 ],
          [ -1-I, -I ],
          [ -2*I, -1 ],
          [ -2*I, 1 ],
          [ 2-2*I, -1 ],
          [ 2-2*I, I ],
          [ 2, -I ],
          [ 2, I ],
          [ 2+2*I, -I ],
          [ 2+2*I, -1 ],
          [ 1+I, I ],
          [ 1+I, -1 ],
          [ -1+I,  1 ],
          [ -1+I, -I ],
          [ -2, 1 ]
          ];
segs_enclose1 = segs_enclose0;
}

{
  segs = Set(concat(segs_enclose0,
                [
                 [ 0, 1 ],

                 \\ extras
                 [ 0, I ],
                 [ 0, -1 ],
                 [ 0, -I ],
                 [ 1-I, -I ],
                 [ 1-I, I ],
                 [ -1-I, 1 ],
                 [ -1-I, I ],
                 [ 1-I, -1 ],
                 [ 1+I, -I ],
                 [ 2, -1 ],

                 \\ extras for expand1
                 [ 1+I, 1 ],
                 [-2*I, I ],
                 [ 1-I, 1 ]
                ]));
}

\\-----------------------------------------------------------------------------
for(i=1,#segs,for(j=i+1,#segs,if(segs[i]==segs[j],print("duplicate ",segs[j]))));
check_exact(vector_unique(segs), segs, "uniqueness");

segs_print(segs) =
{
  my(m=concat([[0,1],
               apply(e->e[1],segs),      \\ segment starts
               apply(vecsum,segs) ]));   \\ segment ends
  my(y_max=vecmax(imag(m)));
  forstep(y=y_max,vecmin(imag(m)),-1,
     if(y<y_max,
       \\ above verticals
       print1("   ");
       for(x=vecmin(real(m)), vecmax(real(m)),
          if(vector_contains(segs,[x+I*y,I]),    print1("^     "),
             vector_contains(segs,[x+I*y+I,-I]), print1("|     "),
                                                 print1("      "));
          );
       print();

       print1("   ");
       for(x=vecmin(real(m)), vecmax(real(m)),
          if(vector_contains(segs,[x+I*y,I]),    print1("|     "),
             vector_contains(segs,[x+I*y+I,-I]), print1("|     "),
                                                 print1("      "));
          );
       print();

       print1("   ");
       for(x=vecmin(real(m)), vecmax(real(m)),
          if(vector_contains(segs,[x+I*y,I]),    print1("|     "),
             vector_contains(segs,[x+I*y+I,-I]), print1("v     "),
                                                 print1("      "));
          );
       print());

     \\ row
     print1("   ");
     for(x=vecmin(real(m)), vecmax(real(m)),
        print1(if(x==0&&y==0,"O","*"));
        if(vector_contains(segs,[x+I*y,1]),    print1(if(x==0&&y==0,
                                                         "====>",
                                                         "---->")),
           vector_contains(segs,[x+1+I*y,-1]), print1("<----"),
                                               print1("     "));
     );
     print();
  );
  print();
}

segs_print(segs_enclose0);
segs_print(segs_enclose1);


lex_complex(a,b) = lex([real(a),imag(a)], [real(b),imag(b)]);
d_to_dir(d) = if(d==1,0, d==I,1, d==-1,2, d==-I,3, d);

elem_to_key(e) = [real(e[1]), imag(e[1]), d_to_dir(e[2])];
my_sort(v) = vecsort(v, (a,b)->lex(elem_to_key(a),elem_to_key(b)));

expand_segments(v) = \
  concat(apply(e->my(z=e[1],d=e[2]); [ [b*z,d], [b*(z+d),d*-I] ], v));

check_exact(expand_segments([[0,1]]), [ [0,1], [1+I,-I] ]);
check_exact(expand_segments([[0,I]]), [ [0,I], [-1+I,1] ]);
check_exact(expand_segments([[0,-1]]), [ [0,-1], [-1-I,I] ]);
check_exact(expand_segments([[-1-I,1]]), [ [-2*I,1], [1-I,-I] ]);

check_exact(expand_segments([[-1+I,-I]]), [ [-2,-I], [-1-I,-1] ]);
check_exact(expand_segments([[-1+I,1]]), [ [-2,1], [-1+I,-I] ]);

\\ my_sort(expand_segments(segs))
print("number of segs ",#segs);

rotate1(v) = apply(e->my(z=e[1],d=e[2]); z-=1+I; [z*I,d*I], v);
expand1(v) = rotate1(expand_segments(v));
check_exact(expand1([[0,1]]), [ [1-I,I], [0,1] ]);
check_exact(expand1([[-1-I,I]]), [ [3-I,-1], [2-2*I,I] ]);

check_exact(setminus(Set(segs),Set(expand_segments(segs))), [], "expand0");
check_exact(setminus(Set(segs),Set(expand1(segs))),         [], "expand1");

\\  0 ------> 1         1 ------> 0
\\   0\     /1           1\     /0
\\ 0a  \   /  1b       1a  \   /  0b
\\     1v v0               0v v1
segs_set = Set(segs);
transition(state,bit) =
{
  if(state[1]==bit,
     \\ a 0,0 or 1,1
     concat([bit],
            setintersect(Set(expand_segments(state[^1])), segs_set)),

     \\ b 0,1 or 1,0
     concat([bit],
            setintersect(Set(expand1(state[^1])), segs_set)));
}
{
  states=List([  Set([0, [0,1]])
              ]);
  my(i=1);
  while(i<=#states,
        for(bit=0,1,
           my(new_state=transition(states[i],bit));
           if(!vector_contains(states,new_state),
              listput(states,new_state);
             \\ print("add ",#states);
             ));
       i++);
}
print("states ",#states);

check_exact(transition(states[1],0), [0, [0,1], [1+I,-I]], "transition 0");
check_exact(transition(states[1],1), [1, [0,1], [1-I,I]], "transition 1");

check_exact(transition([0, [-1+I,-I]],0), [0, [-2,-I], [-1-I,-1]], "transition 0");
check_exact(vector_contains(segs,[-2,-I]),1);
check_exact(vector_contains(segs,[-1-I,-1]),1);

segs_enclose0_set = Set(segs_enclose0);
segs_enclose1_set = Set(segs_enclose1);
state_is_enclosed0(state) = setminus(segs_enclose0_set,state[^1])==[];
state_is_enclosed1(state) = setminus(segs_enclose1_set,state[^1])==[];

for(i=1,#states,if(state_is_enclosed0(states[i]),print("enc0 ",i)));
for(i=1,#states,if(state_is_enclosed1(states[i]),print("enc1 ",i)));

state_to_index(state) =
{
  for(i=1,#states,if(state==states[i],return(i)));
  error("oops, state not found: ",state);
}
state_print(state) =
{
  print("state=",state);
  print("start ",state[1], "  index=",state_to_index(state));
  segs_print(state[^1]);
  print("----------------");
}

\\ enclosures remain enclosed
{
  for(i=1,#states,
     my(state=states[i]);
     \\ print("from");
     \\ state_print(state);
     if(state[1]==0 && state_is_enclosed0(state),
        my(new_state=transition(states[i],0));
        \\ print("to");
        \\ state_print(new_state);
        check_exact(state_is_enclosed0(new_state),1)));
}
{
  for(i=1,#states,
     my(state=states[i]);
     if(state_is_enclosed0(state),
        my(new_state=transition(states[i],0));
        check_exact(state_is_enclosed0(new_state),1);
        new_state=transition(states[i],1);
        check_exact(state_is_enclosed0(new_state),1)));
}

\\ print table
{
  for(i=1,#states,
     print("  "i"=>{0=>" state_to_index(transition(states[i],0)),
           ",1=>", state_to_index(transition(states[i],1)), "},"));
}

\\ eventually enclosing
eventually_states=Set(select(state->state_is_enclosed0(state) \
                                    ||state_is_enclosed1(state),states));
{
  my(more=1);
  while(more,
        more=0;
        for(i=1,#states,
           my(state=states[i]);
           if(setsearch(eventually_states,state),next());
           if(setsearch(eventually_states,transition(state,0))
              && setsearch(eventually_states,transition(state,1)),
             eventually_states=setunion(eventually_states,[state]);
             more=1)));
}
print("eventually enclosing");
\\print(eventually_states);
print(apply(state_to_index,eventually_states));
print("count ",#eventually_states);
print("leaving ",#states-#eventually_states);



print("runs");
{
  my(state=states[1]);
  for(i=1,10,
     state_print(state);
     state=transition(state,0);

     state_print(state);
     state=transition(state,0);

     state_print(state);
     print("now 1");
     state=transition(state,1);

     );
}

transitions(state,v) = for(i=1,#v,state=transition(state,v[i])); state;

fEncPred(f) = {
  my(v=frac_to_fracper(f,2));
  my(state=transitions(states[1],v[^-1])); \\ fixed part
  my(seen=[]);
  v=v[#v];  \\ periodic part
  while(1,
        seen=setunion(seen,[state]);
        state=transitions(state,v);
        if(setsearch(seen,state),break()));
  if(state[1]==0,
     state_is_enclosed0(state),
     state_is_enclosed1(state));
}
print("sevenths");
frac_to_fracper(8/15,2)
for(i=1,6,print(i,"  ",fEncPred(i/7)));

print("fifteenths");
for(i=1,14,print(i,"  ",fEncPred(i/15)));

print("KM ",fEncPred(KM_sum(8)));
frac_to_fracper(KM_sum(6),2)
