\\ Copyright 2014, 2015, 2017 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.


default(recover,0);
read("dragon-defines.gp");

default(recover,0);
check_count = 0;
check_exact(got,want,name="") =
{
  check_count++;
  if(got!= want,
     print("wrong "name);
     print("got  "got);
     print("want "want);
     quit(1),
     print("ok "check_count" "name));
}

\\-----------------------------------------------------------------------------

TMR_width_ref(k) = sqrt2^k \
    * imag( (b^(k+1)-P2(k+1) - P2(k+1)) / b^k );

TMR_height_ref(k) = sqrt2^k \
    * real( (b^(k+1)-P4(k+1) - P4(k+1)) / b^k );

check_exact(vector(100,k,k++; TMR_width_ref(k)*TMR_height_ref(k)), \
            vector(100,k,k++; TMR(k)), \
            "TMR w*h");

\\ TMR_height_ref(100) / sqrt2^100 * 1.0
\\ vector(16,k,k--; TMR_height_ref(k) - 5/3*sqrt2^k)

TMR_width(k) = 7/3*sqrt2^k - 1/3*vector_modulo([4, sqrt2, 2, 2*sqrt2],k);
check_exact(vector(100,k,k++; TMR_width(k)), \
            vector(100,k,k++; TMR_width_ref(k)));

TMR_height(k) = 5/3*sqrt2^k - 1/3*vector_modulo([2, 2*sqrt2, 4, sqrt2],k);
check_exact(vector(100,k,k++; TMR_height(k)), \
            vector(100,k,k++; TMR_height_ref(k)));

vector(32,k,k--; TMR_width(k) >= TMR_height(k))

\\-----------------------------------------------------------------------------

TMRdiag_width_ref(k) = sqrt2^(k+1) \
    * real( (b^(k+1)-P4(k+1) - P4(k+1)) / b^(k+1) );

TMRdiag_height_ref(k) = sqrt2^(k+1) \
    * imag( (b^(k+1)-P2(k+1) - P2(k+1)) / b^(k+1) );

check_exact(vector(100,k,k++; TMRdiag_width_ref(k)*TMRdiag_height_ref(k)), \
            vector(100,k,k++; TMRdiag(k)), \
            "TMRdiag w*h");

\\ my(k=1000); TMRdiag_width_ref(k) / sqrt2^(k+1) * 1.0
\\ vector(16,k,k--; TMRdiag_width_ref(k) - 5/3*sqrt2*sqrt2^k)

TMRdiag_width(k) = 5/3*sqrt2*sqrt2^k - 1/3*vector_modulo([2*sqrt2, 4, sqrt2, 2],k);
check_exact(vector(100,k,k++; TMRdiag_width(k)), \
            vector(100,k,k++; TMRdiag_width_ref(k)));

TMRdiag_height(k) = 4/3*sqrt2*sqrt2^k - 1/3*vector_modulo([sqrt2, 2, 2*sqrt2,4],k);
check_exact(vector(100,k,k++; TMRdiag_height(k)), \
            vector(100,k,k++; TMRdiag_height_ref(k)));

\\ vector(32,k,k--; TMRdiag_width(k) >= TMRdiag_height(k))

vector(50,k,k--; TMR_width(k) < TMRdiag_width(k))
vector(50,k,k--; TMR_height(k) < TMRdiag_height(k))
