#!/usr/bin/perl -w

# Copyright 2019 Kevin Ryde
#
# This file is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 3, or (at your option) any later
# version.
#
# This file is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License along
# with this file.  If not, see <http://www.gnu.org/licenses/>.

use 5.004;
use strict;
use Math::PlanePath::DragonCurve 117; # v.117 for level_to_n_range()

use FindBin;
use lib $FindBin::Bin;
use MyDragon;
use MyPrintwrap ':all';


my $n_max = 22;

print "  % generated by tools/$FindBin::Script\n";

print "  \\matrix (m) [nodes={font=\\scriptsize,anchor=base,inner xsep=.15em}] {\n";
$Printwrap = 2;

printwrap(" &");
foreach my $n (0 .. $n_max) {
  my $degree = MyDragon::TAdegreeInf($n);
  ($degree==3) == ($n%8 == 2 || $n%8 == 5) or die;
  printwrap(($degree == 3 ? " \\pic {my down arrow};" : '')
            .
            ' &');
}
printwrap_newline();
printwrap(" \\\\[.2ex]\n");

printwrap(" \\node[font=\\small] {\$n = {}\$}; &");
foreach my $n (0 .. $n_max) {
  printwrap(" \\node ".($n==12 ? '(p12) ' : '')."{$n}; &");
}
printwrap(" \\node {\\MyTightDots};\n");
printwrap(" \\\\[-.3ex]\n");

printwrap(" \\node[font=\\small] {\$\\mathit{TAdegree}(\\infty,n) = {}\$}; &");
my @degrees;
foreach my $n (0 .. $n_max) {
  my $degree = MyDragon::TAdegreeInf($n);
  printwrap(" \\node {$degree}; &");
  push @degrees, $degree;
}
printwrap(" \\node {\\MyTightDots};\n");
printwrap(" \\\\\n");

printwrap(" &");
foreach my $n (0 .. $n_max) {
  my $degree = MyDragon::TAdegreeInf($n);
  printwrap(($degree==1 ? " \\pic {my up arrow};" : '')
            .
            ' &');
}
printwrap_newline();
printwrap(" \\\\\n");

print "  };\n";
print "% GP-Test  vector(",$n_max+1,",n,n--; TADegree_infinite(n)) == \\\n";
print "% GP-Test    [",join(',',@degrees),"]\n";
print "  % end generated\n";
